<center><a href="ex5f.h">Actual source code: ex5f.h</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:31:40+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80"><a name="line1">  1: </a>! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
<a name="line2">  2: </a>!             Include file <font color="#4169E1">for</font> program ex5f.F
<a name="line3">  3: </a>! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
<a name="line4">  4: </a>!
<a name="line5">  5: </a>!  This program uses CPP <font color="#4169E1">for</font> preprocessing, as indicated by the use of
<a name="line6">  6: </a>!  PETSc include files in the directory petsc/include/finclude.  This
<a name="line7">  7: </a>!  convention enables use of the CPP preprocessor, which allows the use
<a name="line8">  8: </a>!  of the #include statements that define PETSc objects and variables.
<a name="line9">  9: </a>!
<a name="line10"> 10: </a>!  Use of the conventional Fortran include statements is also supported
<a name="line11"> 11: </a>!  In this <font color="#4169E1">case</font>, the PETsc include files are located in the directory
<a name="line12"> 12: </a>!  petsc/include/foldinclude.
<a name="line13"> 13: </a>!
<a name="line14"> 14: </a>!  Since one must be very careful to include each file no more than once
<a name="line15"> 15: </a>!  in a Fortran routine, application programmers must explicitly list
<a name="line16"> 16: </a>!  each file needed <font color="#4169E1">for</font> the various PETSc components within their
<a name="line17"> 17: </a>!  program (unlike the C/C++ interface).
<a name="line18"> 18: </a>!
<a name="line19"> 19: </a>!  See the Fortran section of the PETSc users manual <font color="#4169E1">for</font> details.
<a name="line20"> 20: </a>!
<a name="line21"> 21: </a>!  The following include statements are generally used in <A href="../../../../docs/manualpages/SNES/SNES.html#SNES">SNES</A> Fortran
<a name="line22"> 22: </a>!  programs:
<a name="line23"> 23: </a>!     petsc.h  - base PETSc routines
<a name="line24"> 24: </a>!     petscvec.h    - vectors
<a name="line25"> 25: </a>!     petscmat.h    - matrices
<a name="line26"> 26: </a>!     petscksp.h    - Krylov subspace methods
<a name="line27"> 27: </a>!     petscpc.h     - preconditioners
<a name="line28"> 28: </a>!     petscsnes.h   - <A href="../../../../docs/manualpages/SNES/SNES.html#SNES">SNES</A> interface
<a name="line29"> 29: </a>!  In addition, we need the following <font color="#4169E1">for</font> use of distributed arrays
<a name="line30"> 30: </a>!     petscda.h     - distributed arrays (DAs)

<a name="line32"> 32: </a> #include <A href="../../../../include/finclude/petsc.h.html">include/finclude/petsc.h</A>
<a name="line33"> 33: </a> #include <A href="../../../../include/finclude/petscvec.h.html">include/finclude/petscvec.h</A>
<a name="line34"> 34: </a> #include <A href="../../../../include/finclude/petscda.h.html">include/finclude/petscda.h</A>
<a name="line35"> 35: </a> #include <A href="../../../../include/finclude/petscis.h.html">include/finclude/petscis.h</A>
<a name="line36"> 36: </a> #include <A href="../../../../include/finclude/petscmat.h.html">include/finclude/petscmat.h</A>
<a name="line37"> 37: </a> #include <A href="../../../../include/finclude/petscksp.h.html">include/finclude/petscksp.h</A>
<a name="line38"> 38: </a> #include <A href="../../../../include/finclude/petscpc.h.html">include/finclude/petscpc.h</A>
<a name="line39"> 39: </a> #include <A href="../../../../include/finclude/petscsnes.h.html">include/finclude/petscsnes.h</A>

<a name="line41"> 41: </a>!  Common blocks:
<a name="line42"> 42: </a>!  In this example we use common blocks to store data needed by the
<a name="line43"> 43: </a>!  application-provided call-back routines, FormJacobian() and
<a name="line44"> 44: </a>!  FormFunction().  Note that we can store (pointers to)
<a name="line45"> 45: </a>!  PETSc objects within these common blocks.
<a name="line46"> 46: </a>!
<a name="line47"> 47: </a>!  common /params/ - contains parameters <font color="#4169E1">for</font> the global application
<a name="line48"> 48: </a>!     mx, my   - global discretization in x- and y-directions
<a name="line49"> 49: </a>!     lambda   - nonlinearity parameter
<a name="line50"> 50: </a>!
<a name="line51"> 51: </a>!  common /pdata/  - contains some parallel data
<a name="line52"> 52: </a>!     da       - distributed array
<a name="line53"> 53: </a>!     <A href="../../../../docs/manualpages/Sys/rank.html#rank">rank</A>     - processor <A href="../../../../docs/manualpages/Sys/rank.html#rank">rank</A> within communicator
<a name="line54"> 54: </a>!     <A href="../../../../docs/manualpages/Sys/size.html#size">size</A>     - number of processors
<a name="line55"> 55: </a>!     xs, ys   - local starting grid indices (no ghost points)
<a name="line56"> 56: </a>!     xm, ym   - widths of local grid (no ghost points)
<a name="line57"> 57: </a>!     gxs, gys - local starting grid indices (including ghost points)
<a name="line58"> 58: </a>!     gxm, gym - widths of local grid (including ghost points)

<a name="line60"> 60: </a>      <A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A>      da
<a name="line61"> 61: </a>      <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> xs,xe,xm,gxs,gxe,gxm
<a name="line62"> 62: </a>      <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> ys,ye,ym,gys,gye,gym
<a name="line63"> 63: </a>      <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> mx,my
<a name="line64"> 64: </a>      <A href="../../../../docs/manualpages/Sys/PetscMPIInt.html#PetscMPIInt">PetscMPIInt</A> <A href="../../../../docs/manualpages/Sys/rank.html#rank">rank</A>,<A href="../../../../docs/manualpages/Sys/size.html#size">size</A>
<a name="line65"> 65: </a>      double precision lambda

<a name="line67"> 67: </a>      common /params/ lambda,mx,my
<a name="line68"> 68: </a>      common /pdata/  xs,xe,xm,gxs,gxe,gxm
<a name="line69"> 69: </a>      common /pdata/  ys,ye,ym,gys,gye,gym
<a name="line70"> 70: </a>      common /pdata/  da,<A href="../../../../docs/manualpages/Sys/rank.html#rank">rank</A>,<A href="../../../../docs/manualpages/Sys/size.html#size">size</A>

<a name="line72"> 72: </a>! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
</pre>
</body>

</html>
